package org.dromara.work.service;

import com.github.yulichang.base.MPJBaseService;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.work.domain.TpReceipt;
import org.dromara.work.domain.bo.TpReceiptBo;
import org.dromara.work.domain.vo.ReceiptSumVo;
import org.dromara.work.domain.vo.TpReceiptVo;

import java.util.Collection;
import java.util.List;

/**
 * 收款管理Service接口
 *
 * @author Maosw
 * @date 2024-08-12
 */
public interface ITpReceiptService extends MPJBaseService<TpReceipt> {

    /**
     * 查询收款管理
     *
     * @param id 主键
     * @return 收款管理
     */
    TpReceiptVo queryById(Long id);

    /**
     * 分页查询收款管理列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 收款管理分页列表
     */
    TableDataInfo<TpReceiptVo> queryPageList(TpReceiptBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的收款管理列表
     *
     * @param bo 查询条件
     * @return 收款管理列表
     */
    List<TpReceiptVo> queryList(TpReceiptBo bo);

    /**
     * 新增收款管理
     *
     * @param bo 收款管理
     * @return 是否新增成功
     */
    Boolean insertByBo(TpReceiptBo bo);

    /**
     * 修改收款管理
     *
     * @param bo 收款管理
     * @return 是否修改成功
     */
    Boolean updateByBo(TpReceiptBo bo);

    /**
     * 校验并批量删除收款管理信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 汇款信息统计
     *
     * @param bo
     * @return
     */
    ReceiptSumVo queryListSum(TpReceiptBo bo);

    /**
     * 认领汇款
     * @param bo
     * @return
     */
    int updateClaimByBo(TpReceiptBo bo);

    /**
     * 回退汇款
     * @param bo
     * @return
     */
    int updateBackByBo(TpReceiptBo bo);


    /**
     * 新增收款管理
     *
     * @param bo 收款管理
     * @return 是否新增成功
     */
    Boolean insertReceipt(TpReceiptBo bo);
}
